#ifndef __PSDCLASS_H__
#define __PSDCLASS_H__

//#define LOAD_MEMORY

#include <tp_stub.h>
#include "psdparse/psdfile.h"

class PSDStorage;
class PSDIterator;

class PSD : public psd::PSDFile
{
	friend class PSDStorage;
	friend class PSDIterator;
	
public:
	/**
	 * RXgN^
	 */
	PSD(iTJSDispatch2 *objthis);

	/**
	 * fXgN^
	 */
	~PSD();

	/**
	 * f[^̏
	 */
	virtual void clearData();
	
	/**
	 * CX^Xt@Ng
	 */
	static tjs_error factory(PSD **result, tjs_int numparams, tTJSVariant **params, iTJSDispatch2 *objthis);

	/**
	 * ̎ȃIuWFNg擾
	 */
	tTJSVariant getSelf();
	
	/**
	 * PSD摜̃[h
	 * @param filename t@C
	 * @return [hɐ true
	 */
	bool load(ttstr filename);

	static void clearStorageCache();
	
#define INTGETTER(tag) int get_ ## tag(){ return isLoaded ? header.tag : -1; }

	INTGETTER(width);
	INTGETTER(height);
	INTGETTER(channels);
	INTGETTER(depth);
  int get_color_mode()  { return isLoaded ? header.mode : -1; }
  int get_layer_count() { return isLoaded ? (int)layerList.size() : -1; }

public:
	/**
	 * Cʂ̎擾
	 * @param no Cԍ
	 * @return C
	 */
	int getLayerType(int no);

	/**
	 * Ĉ̎擾
	 * @param no Cԍ
	 * @return C
	 */
	ttstr getLayerName(int no);

	/**
	 * C̎擾
	 * @param no Cԍ
	 * @return C񂪊i[ꂽ
	 */
	tTJSVariant getLayerInfo(int no);

	/**
	 * Cf[^̓ǂݏo()
	 * @param layer ǂݏo惌C
	 * @param no Cԍ
     * @param imageMode C[W[h
	 */
  void _getLayerData(tTJSVariant layer, int no, psd::ImageMode imageMode);

	/**
	 * Cf[^̓ǂݏo
	 * @param layer ǂݏo惌C
	 * @param no Cԍ
	 */
	void getLayerData(tTJSVariant layer, int no);

	/**
	 * Cf[^̓ǂݏo(C[W)
	 * @param layer ǂݏo惌C
	 * @param no Cԍ
	 */
	void getLayerDataRaw(tTJSVariant layer, int no);

	/**
	 * Cf[^̓ǂݏo(}XN̂)
	 * @param layer ǂݏo惌C
	 * @param no Cԍ
	 */
	void getLayerDataMask(tTJSVariant layer, int no);

	/**
	 * XCXf[^̓ǂݏo
	 * @return XCX񎫏 %[ top, left, bottom, right, slices:[ %[ id, group_id, left, top, bottom, right ], ... ] ]
	 *         XCX񂪂Ȃꍇ void Ԃ
	 */
	tTJSVariant getSlices();

	/**
	 * KChf[^̓ǂݏo
	 * @return KCh񎫏 %[ vertical:[ x1, x2, ... ], horizontal:[ y1, y2, ... ] ]
	 *         KCh񂪂Ȃꍇ void Ԃ
	 */
	tTJSVariant getGuides();

	/**
	 * ʂ̎擾B擾͉̈摜S̃TCYɂ܂ĂKv܂
   * ӁFPSDt@Ĉɍς݉摜݂Ȃꍇ͎擾Ɏs܂
   *
	 * @param layer i[惌C(width,heightTCYɒ)
	 * @return 擾ɐ true
	 */
  bool getBlend(tTJSVariant layer);

	/**
	 * C[Jv
	 */
	tTJSVariant getLayerComp();

protected:
	iTJSDispatch2 *objthis; ///< ȃIuWFNg̎Q
	ttstr dname; ///< o^px[X

#ifdef LOAD_MEMORY
	HGLOBAL hBuffer; // Iێpnh
	bool loadMemory(const ttstr &filename);
	void clearMemory();
#else
	// Xg[ǂݍ
	IStream *pStream;
	tTVInteger mStreamSize;
	bool loadStream(const ttstr &filename);
	void clearStream();
	unsigned char &getStreamValue(const tTVInteger &pos);
	void copyToBuffer(uint8_t *buf, tTVInteger pos, int size);

	//< PSDt@Cǂݍ݃LbVpobt@
	tTVInteger mBufferPos;
	ULONG mBufferSize;
	unsigned char mBuffer[4*1024];
#endif
	
	/**
	 * CԍK؂ǂ
	 * @param no Cԍ
	 */
	void checkLayerNo(int no);

	/**
	 * O̎擾
	 * @param layC
	 */
	static ttstr layname(psd::LayerInfo &lay);
	
	// ------------------------------------------------------------
	// Xg[WCQƗpC^[tF[X
	// ------------------------------------------------------------
	
protected:

	// Xg[Wo^
	void addToStorage(const ttstr &filename);
	void removeFromStorage();

	bool storageStarted; //< Xg[Wp̏񏉊ς݃tO

	// CԂ
	static ttstr path_layname(psd::LayerInfo &lay);

	// C̃pXԂ
	static ttstr pathname(psd::LayerInfo &lay);

	// Xg[Wpf[^̏
	void startStorage();

	/*
	 * w肵ÕC̑݃`FbN
	 * @param name pX܂ރC
	 * @param layerIdxRet CCfbNXԍԂ
	 */
	bool CheckExistentStorage(const ttstr &filename, int *layerIdxRet=0);

	/*
	 * w肵pXɂt@Cꗗ̎擾
	 * @param pathname pX
	 * @param lister Xg擾pC^[tF[X
	 */
	void GetListAt(const ttstr &pathname, iTVPStorageLister *lister);

	/*
	 * w肵ÕC̉摜t@CXg[ŕԂ
	 * @param name pX܂ރC
	 * @return t@CXg[
	 */
	IStream *openLayerImage(const ttstr &name);
	
	// pXL^p

	typedef std::map<int,int> LayerIdIdxMap; // layerId ƃCCfbNX̃}bv
	LayerIdIdxMap layerIdIdxMap;

	typedef std::map<ttstr,int> NameIdxMap;     //< ClayerId ̃}bv
	typedef std::map<ttstr,NameIdxMap> PathMap; //< pXʂ̃Cꗗ
	PathMap pathMap;
};

#endif
